#!/bin/sh -e
# $Id: srcUP.m4,v 1.4 2004/09/25 19:46:46 babolo Exp $
           rm=/bin/rm
           sh=/bin/sh
          cat=/bin/cat
         date=/bin/date
        mkdir=/bin/mkdir
     realpath=/bin/realpath
           id=/usr/bin/id
           tr=/usr/bin/tr
          cvs=/usr/bin/cvs
         head=/usr/bin/head
         tail=/usr/bin/tail
         make=/usr/bin/make
         grep=/usr/bin/grep
        uname=/usr/bin/uname
        lockf=/usr/bin/lockf
        patch=/usr/bin/patch
      dirname=/usr/bin/dirname
     basename=/usr/bin/basename
 mkinittmpdir=/usr/bin/mkinittmpdir
           pw=/usr/sbin/pw
        chown=/usr/sbin/chown
          su2=/usr/local/bin/su2
        cvsup=/usr/local/bin/cvsup

    groupfile=/etc/group
     passfile=/etc/passwd
        suser=CVShome
        su_id=65536
      tmplock=/tmp/srcUP.lock
      cvslock=/home/${suser}/`${uname}`/.srcUP.lock
       cvshis=/home/${suser}/`${uname}`/.srcUP.history
     localhis=/home/LOCAL/.srcUP.history
      srclock=/usr/src/.srcUP.lock
       srchis=/usr/src/.srcUP.history
     portshis=/usr/ports/.srcUP.history
       cvserv=anoncvs@cvs.pike.ru:/repo
 FreeBSDCVSup=cvsup2.ru.FreeBSD.org
       supdir=/var/net/sup

patchsrclist="\
    contrib.libpcap.pcap-bpf\
    src.bin.rm\
    src.etc.mtree.var\
    src.etc\
    src.libexec.ftpd\
    src.share.skel\
    src.share.syscons.fonts.koi8-r-thin-8x8\
    src.sys.dev.puc\
    src.sys.miscfs.nullfs\
    src.sys.netinet\
    src.usr.bin.mkinittmpdir\
"

patchportslist="\
    ports.Mk.port.mk\
    ports.TMPDIR\
    ports.graphics.hobbes-icons-xpm\
    ports.mail.nullmailer\
    ports.net.argus\
    ports.news.inn\
"

if  [ -e `${dirname} BINDIR`/etc/srcUP.conf ]; then
    . `${dirname} BINDIR`/etc/srcUP.conf
fi

u=`${id} -un`

case ${1} in
"")
    ${cat} << EOF
srcUP @BABOLO V.M `${cat} BUILDINCLUDEDIR/srcUP.VERSION`
Usage:
  srcUP lock [] -  `${dirname} ${cvslock}`  `${dirname} ${srclock}`
  srcUP cvs -  `${dirname} ${cvslock}`
  srcUP fetch -      
  srcUP local -  `${dirname} ${localhis}`
  srcUP new - 
  srcUP patchports -     
  srcUP patchsrc -     
  srcUP ports -  `${dirname} ${portshis}`
  srcUP src -  `${dirname} ${srclock}`
  srcUP stat -   
  srcUP unlock -  `${dirname} ${cvslock}`  `${dirname} ${srclock}`
EOF
    ;;
stat|look)
    if  [ -e ${cvslock} ] ; then
        echo "`${dirname} ${cvslock}`  `WHOLOCK(cvs)`"
        echo ": `${tail} -1 ${cvslock}`"
    else
        echo "`${dirname} ${cvslock}` :  "
    fi
    if  [ -e ${srclock} ] ; then
        echo "`${dirname} ${srclock}`               `WHOLOCK(src)`"
        echo ": `${tail} -1 ${srclock}`"
    else
        echo "`${dirname} ${srclock}`              :  "
    fi
    echo
    if  [ -e ${cvshis} ]; then
        echo "`${dirname} ${cvshis}` : `${cat} ${cvshis}`"
    else
        echo "`${dirname} ${cvshis}`"
    fi
    if  [ -e ${srchis} ]; then
        echo "`${dirname} ${srchis}`              : `${cat} ${srchis}`"
    else
        echo "`${dirname} ${srchis}`"
    fi
    if  [ -e ${portshis} ]; then
        echo "`${dirname} ${portshis}`            : `${cat} ${portshis}`"
    else
        echo "`${dirname} ${portshis}`"     
    fi
    if  [ -e ${localhis} ]; then
        echo "`${dirname} ${localhis}`           : `${cat} ${localhis}`"
    else
        echo "`${dirname} ${localhis}`"
    fi
    ;;
new)
    EXEPRIV(root,dnl
        if ! ${grep} -q "^${suser}:" ${groupfile}; then
            if ! ${pw} groupadd "${suser}" -qg ${su_id}; then
                echo ": ${pw} groupadd ${suser} -qg ${su_id}"
                exit 1
        fi; fi
        if ! ${grep} -q "^${suser}:" ${passfile}; then
            if ! ${pw} useradd "${suser}" -qu ${su_id} -g ${su_id} -c 'CVS owner' -w no; then
                echo ": ${pw} useradd ${suser} -qu ${su_id} -g ${su_id} -c 'CVS owner' -w no"
                exit 1
        fi; fi
        ${mkdir} -p `${dirname} ${cvslock}` `${dirname} ${srclock}` `${dirname} ${portshis}` `${dirname} ${localhis}` \`${dirname} `${dirname} ${cvslock}`\`/.ssh ${supdir}
        if  [ -d "`${dirname} ${srclock}`/CVS" ]; then
            if  [ \`${cat} `${dirname} ${srclock}`/CVS/Root\` != `${dirname} ${cvslock}` ]; then
                echo ": \`${cat} `${dirname} ${srclock}`/CVS/Root\` != `${dirname} ${cvslock}`"
            fi
            if  [ \`${cat} `${dirname} ${srclock}`/CVS/Repository\` != "src" ]; then
                echo ": \`${cat} `${dirname} ${srclock}`/CVS/Repository\` != src"
            fi
            if  [ \`${cat} `${dirname} ${srclock}`/CVS/Tag\` != "TRELENG_4" ]; then
                echo ": \`${cat} `${dirname} ${srclock}`/CVS/Tag\` != TRELENG_4"
            fi
        else
            ${mkdir} "`${dirname} ${srclock}`/CVS"
            echo "`${dirname} ${cvslock}`" > "`${dirname} ${srclock}`/CVS/Root"
            echo "src" > "`${dirname} ${srclock}`/CVS/Repository"
            echo "TRELENG_4" > "`${dirname} ${srclock}`/CVS/Tag"
            echo "" > "`${dirname} ${srclock}`/CVS/Entries"
        fi
        if  [ -d "`${dirname} ${portshis}`/CVS" ]; then
            if  [ \`${cat} `${dirname} ${portshis}`/CVS/Root\` != `${dirname} ${cvslock}` ]; then
                echo ": \`${cat} `${dirname} ${portshis}`/CVS/Root\` != `${dirname} ${cvslock}`"
            fi
            if  [ \`${cat} `${dirname} ${portshis}`/CVS/Repository\` != "ports" ]; then
                echo ": \`${cat} `${dirname} ${portshis}`/CVS/Repository\` != ports"
            fi
        else
            ${mkdir} "`${dirname} ${portshis}`/CVS"
            echo "`${dirname} ${cvslock}`" > "`${dirname} ${portshis}`/CVS/Root"
            echo "ports" > "`${dirname} ${portshis}`/CVS/Repository"
            echo "" > "`${dirname} ${portshis}`/CVS/Entries"
        fi
        if  [ -d "`${dirname} ${localhis}`/CVS" ]; then
            if  [ \`${cat} `${dirname} ${localhis}`/CVS/Root\` != "${cvserv}/ports" ]; then
                echo ": \`${cat} `${dirname} ${localhis}`/CVS/Root\` != ${cvserv}/ports"
            fi
            if  [ \`${cat} `${dirname} ${localhis}`/CVS/Repository\` != "." ]; then
                echo ": \`${cat} `${dirname} ${localhis}`/CVS/Repository\` != ."
            fi
        else
            ${mkdir} "`${dirname} ${localhis}`/CVS"
            echo "${cvserv}/ports" > "`${dirname} ${localhis}`/CVS/Root"
            echo "." > "`${dirname} ${localhis}`/CVS/Repository"
            echo "" > "`${dirname} ${localhis}`/CVS/Entries"
        fi
        ${chown} -R "${suser}:${suser}" `${dirname} ${cvslock}` `${dirname} ${srclock}` `${dirname} ${portshis}` `${dirname} ${localhis}` \`${dirname} `${dirname} ${cvslock}`\`/.ssh ${supdir}
)dnl
    ;;
lock)
    shift
    EXEPRIV("${suser}",dnl
        TESTLOCK(cvs,dnl
            if  ${lockf} -kst0 ${cvslock} ${sh} -c "(echo ${u}; echo $*) > ${cvslock}"; then
                TESTLOCK(cvs,dnl
                    if  ! ${lockf} -kst0 ${srclock} ${sh} -c "(echo ${u}; echo $*) > ${srclock}"; then
                        ${rm} -f ${srclock}
                        ${rm} -f ${cvslock}
                        echo ":    `${dirname} ${srclock}`"
                    fi
               )dnl
            else
                ${rm} -f ${cvslock}
                echo ":    `${dirname} ${cvslock}`"
            fi
))dnl
    ;;
unlock)
    EXEPRIV("${suser}",dnl
        TESTLOCK(src, ${rm} -f ${srclock})
        TESTLOCK(cvs, ${rm} -f ${cvslock})
)dnl
    ;;
cvs)
    if  [ -n "${2}" ]; then
        FreeBSDCVSup="${2}"
        if  [ -n "${3}" ]; then
            i=`${dirname} ${cvslock}`
            cvslock="`${dirname} ${i}`/${3}/`${basename} ${cvslock}`"
            cvshis="`${dirname} ${i}`/${3}/`${basename} ${cvshis}`"
    fi; fi

    EXEPRIV("${suser}",dnl

5<< EOP
*default host=${FreeBSDCVSup}
*default base=`${dirname} ${supdir}`
*default prefix=`${dirname} ${cvslock}`
*default release=cvs
*default delete use-rel-suffix
#*default compress

cvs-all
EOP
        TESTLOCK(cvs)
        ${cvsup} -gL2 /dev/fd/5
        STAMP > ${cvshis}
)dnl
    ;;
local)
    EXEPRIV("${suser}",dnl
        cd `${dirname} ${localhis}`
        ${cvs} -qR up -dAP
        ./MAKE in
        STAMP > ${localhis}
)dnl
    ;;
src)
    EXEPRIV("${suser}",dnl
        TESTLOCK(cvs)
        TESTLOCK(src)
        cd `${dirname} ${srclock}`
        ${cvs} -qR up -dP
        STAMP > ${srchis}
)dnl
    ;;
patchsrc)
    EXEPRIV("${suser}",dnl
        GETOTMP(babolo/patchFBSD)
        TESTLOCK(src)
        ${mkdir} -p `${dirname} ${srclock}`/usr.bin/mkinittmpdir
        echo ${patchsrclist}
        for i in ${patchsrclist}; do
            ${patch} -Esd `${dirname} ${srclock}` -i \${TMPDIR}/babolo/patchFBSD/\${i}.patch
        done
)dnl
    ;;
patchports)
    EXEPRIV("${suser}",dnl
        GETOTMP(babolo/patchFBSD)
        for i in ${patchportslist}; do
            ${patch} -Esd `${dirname} ${portshis}` -i \${TMPDIR}/babolo/patchFBSD/\${i}.patch
        done
)dnl
    ;;
ports)
    EXEPRIV("${suser}",dnl
        TESTLOCK(cvs)
        cd `${dirname} ${portshis}`
        ${cvs} -qR up -dAP
        STAMP > ${portshis}
)dnl
    ;;
fetch)
    t=0
    for i in `${make} -V SUBDIR`; do
        t=$(( ${t} + 1 ))
        (cd ${i}; `${realpath} ${0}` fetch)
    done
    if  [ ${t} -eq 0 ]; then
        EXEPRIV("${suser}",
            ${make} fetch-recursive
)dnl
    fi
    ;;
*)
    ${0}
    exit 1
    ;;
esac
